// Copyright Epic Games, Inc. All Rights Reserved.
/*===========================================================================
	Generated code exported from UnrealHeaderTool.
	DO NOT modify this manually! Edit the corresponding .h files instead!
===========================================================================*/

#include "UObject/GeneratedCppIncludes.h"
#include "AGXUnreal/Public/Vehicle/AGX_TrackWheel.h"
#include "AGXUnreal/Public/AGX_RigidBodyReference.h"
#include "AGXUnreal/Public/AGX_SceneComponentReference.h"
PRAGMA_DISABLE_DEPRECATION_WARNINGS
void EmptyLinkFunctionForGeneratedCodeAGX_TrackWheel() {}

// Begin Cross Module References
AGXUNREAL_API UScriptStruct* Z_Construct_UScriptStruct_FAGX_RigidBodyReference();
AGXUNREAL_API UScriptStruct* Z_Construct_UScriptStruct_FAGX_SceneComponentReference();
AGXUNREAL_API UScriptStruct* Z_Construct_UScriptStruct_FAGX_TrackWheel();
AGXUNREALBARRIER_API UEnum* Z_Construct_UEnum_AGXUnrealBarrier_EAGX_TrackWheelModel();
COREUOBJECT_API UScriptStruct* Z_Construct_UScriptStruct_FRotator();
COREUOBJECT_API UScriptStruct* Z_Construct_UScriptStruct_FVector();
UPackage* Z_Construct_UPackage__Script_AGXUnreal();
// End Cross Module References

// Begin ScriptStruct FAGX_TrackWheel
static FStructRegistrationInfo Z_Registration_Info_UScriptStruct_AGX_TrackWheel;
class UScriptStruct* FAGX_TrackWheel::StaticStruct()
{
	if (!Z_Registration_Info_UScriptStruct_AGX_TrackWheel.OuterSingleton)
	{
		Z_Registration_Info_UScriptStruct_AGX_TrackWheel.OuterSingleton = GetStaticStruct(Z_Construct_UScriptStruct_FAGX_TrackWheel, (UObject*)Z_Construct_UPackage__Script_AGXUnreal(), TEXT("AGX_TrackWheel"));
	}
	return Z_Registration_Info_UScriptStruct_AGX_TrackWheel.OuterSingleton;
}
template<> AGXUNREAL_API UScriptStruct* StaticStruct<FAGX_TrackWheel>()
{
	return FAGX_TrackWheel::StaticStruct();
}
struct Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics
{
#if WITH_METADATA
	static constexpr UECodeGen_Private::FMetaDataPairParam Struct_MetaDataParams[] = {
		{ "BlueprintType", "true" },
		{ "Category", "AGX Dynamics" },
		{ "Comment", "/**\n * A track wheel referenced by the Track Component. Specifies the wheel rigid body,\n * the wheel transform, and interaction characteristics against the track nodes.\n *\n * Note that this object does not create any geometries, bodies, or joints on its own,\n * it merely acts a data connection between the already existing actual wheel Rigid Body\n * and the Track Component. In other words, it turns a body into a track wheel.\n * In particular, it will affect the routing of the track.\n *\n * This object is only used at BeginPlay by Track Component.\n */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "A track wheel referenced by the Track Component. Specifies the wheel rigid body,\nthe wheel transform, and interaction characteristics against the track nodes.\n\nNote that this object does not create any geometries, bodies, or joints on its own,\nit merely acts a data connection between the already existing actual wheel Rigid Body\nand the Track Component. In other words, it turns a body into a track wheel.\nIn particular, it will affect the routing of the track.\n\nThis object is only used at BeginPlay by Track Component." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_RigidBody_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 *  The Rigid Body to which this wheel belongs.\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "The Rigid Body to which this wheel belongs." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_FrameDefiningComponent_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * The optional Frame Defining Component makes it possible to use the transform of any Actor\n\x09 * or Component to define the frame of the Track Wheel. If set, RelativeLocation and\n\x09 * RelativeRotation are relative to the Frame Defining Component instead of to the Rigid Body\n\x09 * Component.\n\x09 */" },
		{ "EditCondition", "bUseFrameDefiningComponent" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "The optional Frame Defining Component makes it possible to use the transform of any Actor\nor Component to define the frame of the Track Wheel. If set, RelativeLocation and\nRelativeRotation are relative to the Frame Defining Component instead of to the Rigid Body\nComponent." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_bUseFrameDefiningComponent_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "InlineEditConditionToggle", "" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_RelativeLocation_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * Wheel location relative to the Rigid Body,\n\x09 * or to the FrameDefiningComponent if bUseFrameDefiningComponent is true [cm].\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "Wheel location relative to the Rigid Body,\nor to the FrameDefiningComponent if bUseFrameDefiningComponent is true [cm]." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_RelativeRotation_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * Wheel rotation relative to the Rigid Body,\n\x09 * or to the FrameDefiningComponent if bUseFrameDefiningComponent is true [deg].\n\x09 *\n\x09 * The Y-Axis becomes the rotation-axis, and the Z-axis becomes the up-axis.\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "Wheel rotation relative to the Rigid Body,\nor to the FrameDefiningComponent if bUseFrameDefiningComponent is true [deg].\n\nThe Y-Axis becomes the rotation-axis, and the Z-axis becomes the up-axis." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_Radius_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * Radius of the wheel [cm].\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "Radius of the wheel [cm]." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_Model_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * The wheel type. Sprocket and Idler wheel types will merge track nodes to them,\n\x09 * simulating geared, non-slip, type of properties.\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "The wheel type. Sprocket and Idler wheel types will merge track nodes to them,\nsimulating geared, non-slip, type of properties." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_bSplitSegments_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * Wheels with this property will split segments, i.e., intermediate nodes that are merged.\n\x09 * Use this property on ROLLER models where the track changes angle.\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "Wheels with this property will split segments, i.e., intermediate nodes that are merged.\nUse this property on ROLLER models where the track changes angle." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_bMoveNodesToRotationPlane_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * If enabled - when a node is merged to the wheel, move the node into the plane defined by\n\x09 * the wheel center position and rotation axis. This will prevent the tracks from sliding of\n\x09 * its path but all Sprocket and Idler wheels must be aligned.\n\x09 *\n\x09 * Only relevant for Idler or Sprocket wheels.\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "If enabled - when a node is merged to the wheel, move the node into the plane defined by\nthe wheel center position and rotation axis. This will prevent the tracks from sliding of\nits path but all Sprocket and Idler wheels must be aligned.\n\nOnly relevant for Idler or Sprocket wheels." },
	};
	static constexpr UECodeGen_Private::FMetaDataPairParam NewProp_bMoveNodesToWheel_MetaData[] = {
		{ "Category", "AGX Track Wheel" },
		{ "Comment", "/**\n\x09 * Similar to 'Move Nodes To Rotation Plane' but this property will also make sure\n\x09 * the node is moved to the surface of the wheel.\n\x09 *\n\x09 * Only relevant for Idler or Sprocket wheels.\n\x09 */" },
		{ "ModuleRelativePath", "Public/Vehicle/AGX_TrackWheel.h" },
		{ "ToolTip", "Similar to 'Move Nodes To Rotation Plane' but this property will also make sure\nthe node is moved to the surface of the wheel.\n\nOnly relevant for Idler or Sprocket wheels." },
	};
#endif // WITH_METADATA
	static const UECodeGen_Private::FStructPropertyParams NewProp_RigidBody;
	static const UECodeGen_Private::FStructPropertyParams NewProp_FrameDefiningComponent;
	static void NewProp_bUseFrameDefiningComponent_SetBit(void* Obj);
	static const UECodeGen_Private::FBoolPropertyParams NewProp_bUseFrameDefiningComponent;
	static const UECodeGen_Private::FStructPropertyParams NewProp_RelativeLocation;
	static const UECodeGen_Private::FStructPropertyParams NewProp_RelativeRotation;
	static const UECodeGen_Private::FFloatPropertyParams NewProp_Radius;
	static const UECodeGen_Private::FBytePropertyParams NewProp_Model_Underlying;
	static const UECodeGen_Private::FEnumPropertyParams NewProp_Model;
	static void NewProp_bSplitSegments_SetBit(void* Obj);
	static const UECodeGen_Private::FBoolPropertyParams NewProp_bSplitSegments;
	static void NewProp_bMoveNodesToRotationPlane_SetBit(void* Obj);
	static const UECodeGen_Private::FBoolPropertyParams NewProp_bMoveNodesToRotationPlane;
	static void NewProp_bMoveNodesToWheel_SetBit(void* Obj);
	static const UECodeGen_Private::FBoolPropertyParams NewProp_bMoveNodesToWheel;
	static const UECodeGen_Private::FPropertyParamsBase* const PropPointers[];
	static void* NewStructOps()
	{
		return (UScriptStruct::ICppStructOps*)new UScriptStruct::TCppStructOps<FAGX_TrackWheel>();
	}
	static const UECodeGen_Private::FStructParams StructParams;
};
const UECodeGen_Private::FStructPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_RigidBody = { "RigidBody", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Struct, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, STRUCT_OFFSET(FAGX_TrackWheel, RigidBody), Z_Construct_UScriptStruct_FAGX_RigidBodyReference, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_RigidBody_MetaData), NewProp_RigidBody_MetaData) }; // 4139551435
const UECodeGen_Private::FStructPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_FrameDefiningComponent = { "FrameDefiningComponent", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Struct, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, STRUCT_OFFSET(FAGX_TrackWheel, FrameDefiningComponent), Z_Construct_UScriptStruct_FAGX_SceneComponentReference, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_FrameDefiningComponent_MetaData), NewProp_FrameDefiningComponent_MetaData) }; // 3585849913
void Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bUseFrameDefiningComponent_SetBit(void* Obj)
{
	((FAGX_TrackWheel*)Obj)->bUseFrameDefiningComponent = 1;
}
const UECodeGen_Private::FBoolPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bUseFrameDefiningComponent = { "bUseFrameDefiningComponent", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Bool | UECodeGen_Private::EPropertyGenFlags::NativeBool, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, sizeof(bool), sizeof(FAGX_TrackWheel), &Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bUseFrameDefiningComponent_SetBit, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_bUseFrameDefiningComponent_MetaData), NewProp_bUseFrameDefiningComponent_MetaData) };
const UECodeGen_Private::FStructPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_RelativeLocation = { "RelativeLocation", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Struct, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, STRUCT_OFFSET(FAGX_TrackWheel, RelativeLocation), Z_Construct_UScriptStruct_FVector, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_RelativeLocation_MetaData), NewProp_RelativeLocation_MetaData) };
const UECodeGen_Private::FStructPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_RelativeRotation = { "RelativeRotation", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Struct, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, STRUCT_OFFSET(FAGX_TrackWheel, RelativeRotation), Z_Construct_UScriptStruct_FRotator, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_RelativeRotation_MetaData), NewProp_RelativeRotation_MetaData) };
const UECodeGen_Private::FFloatPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_Radius = { "Radius", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Float, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, STRUCT_OFFSET(FAGX_TrackWheel, Radius), METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_Radius_MetaData), NewProp_Radius_MetaData) };
const UECodeGen_Private::FBytePropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_Model_Underlying = { "UnderlyingType", nullptr, (EPropertyFlags)0x0000000000000000, UECodeGen_Private::EPropertyGenFlags::Byte, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, 0, nullptr, METADATA_PARAMS(0, nullptr) };
const UECodeGen_Private::FEnumPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_Model = { "Model", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Enum, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, STRUCT_OFFSET(FAGX_TrackWheel, Model), Z_Construct_UEnum_AGXUnrealBarrier_EAGX_TrackWheelModel, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_Model_MetaData), NewProp_Model_MetaData) }; // 3252269331
void Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bSplitSegments_SetBit(void* Obj)
{
	((FAGX_TrackWheel*)Obj)->bSplitSegments = 1;
}
const UECodeGen_Private::FBoolPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bSplitSegments = { "bSplitSegments", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Bool | UECodeGen_Private::EPropertyGenFlags::NativeBool, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, sizeof(bool), sizeof(FAGX_TrackWheel), &Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bSplitSegments_SetBit, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_bSplitSegments_MetaData), NewProp_bSplitSegments_MetaData) };
void Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToRotationPlane_SetBit(void* Obj)
{
	((FAGX_TrackWheel*)Obj)->bMoveNodesToRotationPlane = 1;
}
const UECodeGen_Private::FBoolPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToRotationPlane = { "bMoveNodesToRotationPlane", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Bool | UECodeGen_Private::EPropertyGenFlags::NativeBool, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, sizeof(bool), sizeof(FAGX_TrackWheel), &Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToRotationPlane_SetBit, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_bMoveNodesToRotationPlane_MetaData), NewProp_bMoveNodesToRotationPlane_MetaData) };
void Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToWheel_SetBit(void* Obj)
{
	((FAGX_TrackWheel*)Obj)->bMoveNodesToWheel = 1;
}
const UECodeGen_Private::FBoolPropertyParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToWheel = { "bMoveNodesToWheel", nullptr, (EPropertyFlags)0x0010000000000001, UECodeGen_Private::EPropertyGenFlags::Bool | UECodeGen_Private::EPropertyGenFlags::NativeBool, RF_Public|RF_Transient|RF_MarkAsNative, nullptr, nullptr, 1, sizeof(bool), sizeof(FAGX_TrackWheel), &Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToWheel_SetBit, METADATA_PARAMS(UE_ARRAY_COUNT(NewProp_bMoveNodesToWheel_MetaData), NewProp_bMoveNodesToWheel_MetaData) };
const UECodeGen_Private::FPropertyParamsBase* const Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::PropPointers[] = {
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_RigidBody,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_FrameDefiningComponent,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bUseFrameDefiningComponent,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_RelativeLocation,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_RelativeRotation,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_Radius,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_Model_Underlying,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_Model,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bSplitSegments,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToRotationPlane,
	(const UECodeGen_Private::FPropertyParamsBase*)&Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewProp_bMoveNodesToWheel,
};
static_assert(UE_ARRAY_COUNT(Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::PropPointers) < 2048);
const UECodeGen_Private::FStructParams Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::StructParams = {
	(UObject* (*)())Z_Construct_UPackage__Script_AGXUnreal,
	nullptr,
	&NewStructOps,
	"AGX_TrackWheel",
	Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::PropPointers,
	UE_ARRAY_COUNT(Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::PropPointers),
	sizeof(FAGX_TrackWheel),
	alignof(FAGX_TrackWheel),
	RF_Public|RF_Transient|RF_MarkAsNative,
	EStructFlags(0x00000201),
	METADATA_PARAMS(UE_ARRAY_COUNT(Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::Struct_MetaDataParams), Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::Struct_MetaDataParams)
};
UScriptStruct* Z_Construct_UScriptStruct_FAGX_TrackWheel()
{
	if (!Z_Registration_Info_UScriptStruct_AGX_TrackWheel.InnerSingleton)
	{
		UECodeGen_Private::ConstructUScriptStruct(Z_Registration_Info_UScriptStruct_AGX_TrackWheel.InnerSingleton, Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::StructParams);
	}
	return Z_Registration_Info_UScriptStruct_AGX_TrackWheel.InnerSingleton;
}
// End ScriptStruct FAGX_TrackWheel

// Begin Registration
struct Z_CompiledInDeferFile_FID_GitLab_Runner_builds_9YzzThLq_0_algoryx_unreal_agxunreal_s_selfhosted_build_AGXUnreal_HostProject_Plugins_AGXUnreal_Source_AGXUnreal_Public_Vehicle_AGX_TrackWheel_h_Statics
{
	static constexpr FStructRegisterCompiledInInfo ScriptStructInfo[] = {
		{ FAGX_TrackWheel::StaticStruct, Z_Construct_UScriptStruct_FAGX_TrackWheel_Statics::NewStructOps, TEXT("AGX_TrackWheel"), &Z_Registration_Info_UScriptStruct_AGX_TrackWheel, CONSTRUCT_RELOAD_VERSION_INFO(FStructReloadVersionInfo, sizeof(FAGX_TrackWheel), 2758043885U) },
	};
};
static FRegisterCompiledInInfo Z_CompiledInDeferFile_FID_GitLab_Runner_builds_9YzzThLq_0_algoryx_unreal_agxunreal_s_selfhosted_build_AGXUnreal_HostProject_Plugins_AGXUnreal_Source_AGXUnreal_Public_Vehicle_AGX_TrackWheel_h_3669255769(TEXT("/Script/AGXUnreal"),
	nullptr, 0,
	Z_CompiledInDeferFile_FID_GitLab_Runner_builds_9YzzThLq_0_algoryx_unreal_agxunreal_s_selfhosted_build_AGXUnreal_HostProject_Plugins_AGXUnreal_Source_AGXUnreal_Public_Vehicle_AGX_TrackWheel_h_Statics::ScriptStructInfo, UE_ARRAY_COUNT(Z_CompiledInDeferFile_FID_GitLab_Runner_builds_9YzzThLq_0_algoryx_unreal_agxunreal_s_selfhosted_build_AGXUnreal_HostProject_Plugins_AGXUnreal_Source_AGXUnreal_Public_Vehicle_AGX_TrackWheel_h_Statics::ScriptStructInfo),
	nullptr, 0);
// End Registration
PRAGMA_ENABLE_DEPRECATION_WARNINGS
